/*
 * Vocoder
 *  2012 Achim Settelmeier <vocoder@m1.sirlab.de>
 *
 * brings input and output channels together
 */

#ifndef __ENGINE_H__
#define __ENGINE_H__

#include "types.h"
#include "inputtrack.h"
#include "outputtrack.h"
#include "vocoder.h"
#include "options.h"

class Engine{
public:
	Engine(const options_t &options);
	void run();
	void processBlock(InputTrack &formantTrack,
			  InputTrack &carrierTrack,
			  OutputTrack &outputTrack,
			  Vocoder &vocoderLeft,
			  Vocoder &vocoderRight,
			  nframes_t numFramesToProcess);
	
private:
	options_t options;
};

#endif
